### Paddle-TRT 样例的使用

## 内容

- 准备Paddle-TRT库
- 准备测试程序
- 编译程序

#### 一： 准备Paddle-TRT 库

PaddlePaddle官方提供的[使用TensorRT库预测
](http://paddlepaddle.org/documentation/docs/zh/1.2/advanced_usage/deploy/inference/paddle_tensorrt_infer.html)文档中，已经提供了带TensorRT的Paddle库的编译方式。

编译后的库的目录如下：

```
fluid_inference_install_dir
├── paddle
│   ├── ...
│   └── ...
│      
├── CMakeCache.txt
├── version.txt
├── third_party
    ├── boost
    ├── install
    └── engine3
    
```

- 其中，paddle目录下为预测库的头文件(`/paddle/include/*.h`)和预测库的lib库（`/paddle/lib/libpaddle_fluid.so` `/paddle/lib/libpaddle_fluid.a`）。

- version.txt 中显示了该lib的版本和配置信息。
- third_party 中包含了Paddle需要的第三方库。


### 二：准备程序
在这个repo下我们提供了使用Paddle-TRT的单线程和多线程的`Samples`。
目录如下：

```
sample
├── CMakeLists.txt
├── mobilenet_test.cc
├── mobilenetv1
│   ├── model
│   └── params
└── run_impl.sh
```

- `mobilenet_test.cc` 为单线程的程序文件
- `thread_mobilenet_test.cc` 为多线程的程序文件
- `mobilenetv1`为模型文件。



### 三：编译程序
假设我们的Paddle-TRT库的路径为 `$BASE_DIR/fluid_inference_install_dir/`，  该sampel所在的目录为`$SAMPLE_BASE_DIR/sample`

- 编译运行单线程

```
# 进入样例文件目录
cd sample 
# sh run_impl.sh {Paddle-TRT库的地址} {测试脚本的名字} {模型目录}
sh run_impl.sh $BASE_DIR/fluid_inference_install_dir/  mobilenet_test $SAMPLE_BASE_DIR/sample/mobilenetv1
```

- 编译运行多线程

```
# 进入样例文件目录
cd sample 
# sh run_impl.sh {Paddle-TRT库的地址} {测试脚本的名字} {模型目录}
sh run_impl.sh $BASE_DIR/fluid_inference_install_dir/  thread_mobilenet_test $SAMPLE_BASE_DIR/sample/mobilenetv1

```
