#include <gflags/gflags.h>
#include <glog/logging.h>
#include <numeric>
#include <iostream>
#include <memory>
#include <chrono>
#include<random>
#include "paddle/include/paddle_inference_api.h"

namespace paddle {
using paddle::AnalysisConfig;

DEFINE_string(dirname, "./mobilenetv1/", "Directory of the inference model.");

float Random(float low, float high) {
  static std::random_device rd;
  static std::mt19937 mt(rd());
  std::uniform_real_distribution<double> dist(low, high);
  return dist(mt);
}

using Time = decltype(std::chrono::high_resolution_clock::now());
Time time() { return std::chrono::high_resolution_clock::now(); };
double time_diff(Time t1, Time t2) {
  typedef std::chrono::microseconds ms;
  auto diff = t2 - t1;
  ms counter = std::chrono::duration_cast<ms>(diff);
  return counter.count() / 1000.0;
}

void PrepareTRTConfig(AnalysisConfig *config, int batch_size) {
  config->SetModel(FLAGS_dirname + "/model",
                     FLAGS_dirname + "/params");
  config->EnableUseGpu(100, 0);
  // We use ZeroCopyTensor here, so we set config->SwitchUseFeedFetchOps(false)
  config->SwitchUseFeedFetchOps(false);
  config->EnableTensorRtEngine(1 << 20, batch_size, 3, AnalysisConfig::Precision::kInt8, false, true /*use_calib*/);
}

bool test_map_cnn(int batch_size, int repeat) {
  AnalysisConfig config;
  PrepareTRTConfig(&config, batch_size);
  auto predictor = CreatePaddlePredictor(config);

  std::vector<PaddleTensor> inputs;
  int channels = 3;
  int height = 224;
  int width = 224;
  int input_num = channels * height * width * batch_size;
  float *input = new float[input_num];
  memset(input, 0, input_num * sizeof(float));
  // create predictor
  std::vector<PaddleTensor> outputs;
  int index = 0;

  while (index < 500) {
     inputs.clear();

     for (int i = 0; i < input_num; i++) {
       float temp_d;
       input[i] = Random(0, 1.0);
     }

     auto input_names = predictor->GetInputNames();
     auto input_t = predictor->GetInputTensor(input_names[0]);
     input_t->Reshape({batch_size, channels, height, width});
     input_t->copy_from_cpu(input);
     
     CHECK(predictor->ZeroCopyRun());
     index += 1;
  }

  delete input;
  return true;
}
}  // namespace paddle

int main() {
  for (int i = 0; i < 1; i++) {
    paddle::test_map_cnn(1 << i, 1);
  }
  return 0;
}
